texture Tex0;
texture Tex1;
sampler2D smp = sampler_state
{
	texture = <Tex0>;
	MinFilter = Linear;
	MagFilter = Linear;
	MipFilter = None;
};
sampler2D bump = sampler_state
{
	texture = <Tex1>;
	MinFilter = Linear;
	MagFilter = Linear;
	MipFilter = None;
};

float4 LightParams;
float4 ps_main( float2 txc : TEXCOORD0, float2 pos : TEXCOORD1 ) : COLOR0
{
	float4 base = tex2D( smp, txc );
	float3 xpos = float3( pos, 0 );
	float3 N = tex2D( bump, txc ).rgb * 2 - 1;
	float3 dir = normalize( xpos - LightParams.xyz );
	float att = ( 1 - ( length( LightParams.xyz - xpos ) / LightParams.w ) );
	float spec = dot( reflect( dir, N ), float3( 0, 0, 1 ) );
	base.rgb *= saturate( dot( dir, N ) ) * att;
	//base.a = 1;
	return base + pow( spec, 24 ) * float4( 1, 1, 0.2, base.a ) * att;
}

technique T00
{
	pass p0
	{
		MinFilter[ 0 ] = Linear;
		MinFilter[ 1 ] = Linear;
		MagFilter[ 0 ] = Linear;
		MagFilter[ 1 ] = Linear;

		TextureFactor = 0xFFBFBFBF;
		ColorOp[ 0 ] = DotProduct3;
		Texture[ 0 ] = <Tex1>;
		ColorArg1[ 0 ] = Texture;
		ColorArg2[ 0 ] = TFactor;
		AlphaOp[ 0 ] = Disable;

		ColorOp[ 1 ] = Modulate;
		Texture[ 1 ] = <Tex0>;
		TexCoordIndex[ 1 ] = 0;
		ColorArg1[ 1 ] = Texture;
		ColorArg2[ 1 ] = Current;
		AlphaOp[ 1 ] = SelectArg1;
		AlphaArg1[ 1 ] = Texture;
	}
}

technique T20
{
	pass p0
	{
		VertexShader=NULL;
		PixelShader=compile ps_2_0 ps_main();
	}
}