/*texture Tex0;
texture Tex1;
texture Tex2;
texture Tex3;*/
#include "lev_diff.fx"

sampler2D smp = sampler_state
{
	texture = <Tex0>;
	MinFilter = Linear;
	MagFilter = Linear;
	MipFilter = Linear;
};
sampler2D lmap = sampler_state
{
	texture = <Tex1>;
	MinFilter = Linear;
	MagFilter = Linear;
	MipFilter = Linear;
};
sampler2D bump = sampler_state
{
	texture = <Tex2>;
	MinFilter = Linear;
	MagFilter = Linear;
	MipFilter = Linear;
};
sampler2D lbump = sampler_state
{
	texture = <Tex3>;
	MinFilter = Linear;
	MagFilter = Linear;
	MipFilter = Linear;
};

float4x4 mat;

struct VS_IN
{
	float4 pos : POSITION0;
	float2 tc1 : TEXCOORD0;
	float2 tc2 : TEXCOORD1;
};
struct VS_OUT
{
	float4 pos : POSITION0;
	float2 tc1 : TEXCOORD0;
	float2 tc2 : TEXCOORD1;
};

VS_OUT VSBump( VS_IN i )
{
	VS_OUT o;
	o.pos = mul( i.pos, mat );
	o.tc1 = i.tc1;
	o.tc2 = i.tc2;
	return o;
}

float4 PSBump( float2 t1 : TEXCOORD0, float2 t2 : TEXCOORD1, float2 tp : TEXCOORD2 ) : COLOR0
{
	float4 bm = tex2D( bump, t1 );
	float3 nm = bm.rgb * 2 - 1;
	float4 nm2x = tex2D( lbump, t2 );
	float3 nm2 = ( nm2x.rgb ) * 2 - 1;

	float l = dot( nm, nm2 );

	float4 diff = tex2D( smp, t1 );
	float4 lm = tex2D( lmap, t2 + nm.xy * 0.002 );
	lm.rgb *= l;
	diff.rgb *= lm * 2;
	return diff;
}

technique T20
{
	pass p0
	{
		VertexShader = compile vs_1_1 VSBump();
		PixelShader = compile ps_2_0 PSBump();
	}
}//*/texture Tex0;