/*texture Tex0;
texture Tex1;
texture Tex2;
texture Tex3;*/
#include "lev_diff.fx"

sampler2D smp = sampler_state
{
	texture = <Tex0>;
	MinFilter = Linear;
	MagFilter = Linear;
	MipFilter = Linear;
};
sampler2D lmap = sampler_state
{
	texture = <Tex1>;
	MinFilter = Linear;
	MagFilter = Linear;
	MipFilter = Linear;
};
sampler2D bump = sampler_state
{
	texture = <Tex2>;
	MinFilter = Linear;
	MagFilter = Linear;
	MipFilter = Linear;
};
sampler2D lbump = sampler_state
{
	texture = <Tex3>;
	MinFilter = Linear;
	MagFilter = Linear;
	MipFilter = Linear;
};

float3 viewpoint;
float4x4 mat;
const float specpwr = 1024;
float4 ambcolor = 0;

struct VS_IN
{
	float4 pos : POSITION0;
	float2 tc1 : TEXCOORD0;
	float2 tc2 : TEXCOORD1;
};
struct VS_OUT
{
	float4 pos : POSITION0;
	float2 tc1 : TEXCOORD0;
	float2 tc2 : TEXCOORD1;
	float2 tcp : TEXCOORD2;
};

VS_OUT VSBumpSpec( VS_IN i )
{
	VS_OUT o;
	o.pos = mul( i.pos, mat );
	o.tcp = i.pos.xy;
	o.tc1 = i.tc1;
	o.tc2 = i.tc2;
	return o;
}

float4 PSBumpSpec( float2 t1 : TEXCOORD0, float2 t2 : TEXCOORD1, float2 tp : TEXCOORD2 ) : COLOR0
{
	float4 bm = tex2D( bump, t1 );
	float3 nm = normalize( bm.rgb * 2 - 1 );
	float4 nm2x = tex2D( lbump, t2 );
	float3 nm2 = ( nm2x.rgb ) * 2 - 1;

	float l = dot( nm, nm2 );

	float3 viewdir = normalize( viewpoint - float3( tp, 0 ) );
	float3 ref = reflect( normalize( float3(nm2.xy*4.5,nm2.z) ), nm );
	float rdv = saturate( pow( dot( -viewdir, ref ), 32 ) );

	float4 diff = tex2D( smp, t1 );
	float4 lm = tex2D( lmap, t2 );
/*
	lm += tex2D( lmap, t2 + float2( 0.001, 0 ) );
	lm += tex2D( lmap, t2 + float2( -0.001, 0 ) );

	lm += tex2D( lmap, t2 + float2( 0, 0.001 ) );
	lm += tex2D( lmap, t2 + float2( 0, -0.001 ) );
	lm /= 5;
*/
	float4 lmc = lm; lmc.rgb *= l;
	diff.rgb *= lmc * 2;
	//diff.a *= 0.5f;
	float4 specsum = rdv * bm.a * ( lm - ambcolor );
	specsum.a *= diff.a;

	return diff + specsum;
	//return float4( nm2 * 0.5 + 0.5, 1 );
	//return float4( 0, 0, 0, diff.a ) + pow( rdv, specpwr ) * bm.a * ( lm - ambcolor ) * 2;
}

technique T20
{
	pass p0
	{
		VertexShader = compile vs_1_1 VSBumpSpec();
		PixelShader = compile ps_2_0 PSBumpSpec();
	}
}//*/