texture Tex0;
texture Tex1;
sampler2D rtt = sampler_state
{
	texture = <Tex0>;
	AddressU = Clamp;
	AddressV = Clamp;
	//MinFilter = Linear;
	//MagFilter = Linear;
	//MipFilter = Linear;
};
sampler2D htt = sampler_state
{
	texture = <Tex1>;
	MinFilter = Linear;
	MagFilter = Linear;
	MipFilter = Linear;
};

technique T00
{
	pass p0
	{
		Texture[ 0 ] = <Tex0>;
		ColorOp[ 0 ] = Modulate;
		ColorArg1[ 0 ] = Texture;
		ColorArg2[ 0 ] = Diffuse;

		ResultArg[ 1 ] = Temp;
		Texture[ 1 ] = <Tex1>;
		TexCoordIndex[ 1 ] = 0;
		ColorOp[ 1 ] = AddSigned2X;
		ColorArg1[ 1 ] = Current;
		ColorArg2[ 1 ] = Texture;

		TexCoordIndex[ 2 ] = 0;
		ColorOp[ 2 ] = Lerp;
		ColorArg1[ 2 ] = Current;
		ColorArg2[ 2 ] = Temp;
		ColorArg0[ 2 ] = Specular | Complement;
		AlphaOp[ 2 ] = SelectArg1;
		AlphaArg1[ 2 ] = Diffuse;

		AddressU[ 0 ] = Clamp;
		AddressV[ 0 ] = Clamp;
/*
		MinFilter[ 0 ] = Linear;
		MagFilter[ 0 ] = Linear;
		MipFilter[ 0 ] = Linear;
*/
		MinFilter[ 1 ] = Linear;
		MagFilter[ 1 ] = Linear;
		MipFilter[ 1 ] = Linear;
	}
}


float4 PostProcFX14( float2 tc : TEXCOORD0, float4 c0 : COLOR0, float4 c1 : COLOR1 ) : COLOR0
{
	tc += float2( 1.0, 1.0 ) * 0.001;
	float4 tex_base = tex2D( rtt, tc ) * c0;
	float4 tex_fx = ( tex_base + tex2D( htt, tc ) - float4(0.5,0.5,0.5,0.5) ) * 2.0;
	float4 fin = float4( lerp( tex_base, saturate( tex_fx ), c1 ).rgb, c0.a );
	return fin;
}
float4 PostProcFX2( float2 tc : TEXCOORD0, float4 c0 : COLOR0, float4 c1 : COLOR1 ) : COLOR0
{
	tc += float2( 1, 1 ) * 0.001;
	float4 tex_base = tex2D( rtt, tc ) * c0;
	float4 tex_fx = ( tex_base + tex2D( htt, tc ) - float4(0.5,0.5,0.5,0.5) ) * 2;
	float4 fin = float4( lerp( tex_base, saturate( tex_fx ), c1 ).rgb, c0.a );
	float4 bwf = float4( ( dot( fin.rgb, 1 ) / 3 ).xxx, c0.a );
	bwf.rgb -= 0.5f;
	bwf.rgb *= 2;
	bwf.rgb += 0.5f;
	float4 bwl = lerp( fin, bwf, c1 );
	return bwl;
}
technique T14
{
	pass p0
	{
		VertexShader = NULL;
		PixelShader = compile ps_1_4 PostProcFX14();
	}
}
technique T20
{
	pass p0
	{
		VertexShader = NULL;
		PixelShader = compile ps_2_0 PostProcFX14();
	}
}